/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <DlgUnidraw/dlgclasses.h>
#include <DlgUnidraw/dlgcmds.h>
#include <DlgUnidraw/dlgcomps.h>
#include <DlgUnidraw/dlgcreator.h>
#include <DlgUnidraw/dlgscripts.h>

#include <MapUnidraw/mapscripts.h>
#include <MapUnidraw/mapviews.h>

#include <OverlayUnidraw/ovclasses.h>
#include <OverlayUnidraw/ovpsview.h>

#include <Unidraw/catalog.h>



DlgCreator::DlgCreator () { }

void* DlgCreator::Create (
    ClassId id, istream& in, ObjectMap* objmap, int objid
) {
    switch (id) {
        case DLGSHOW_CMD:          CREATE(DlgShowCmd, in,objmap,objid);

        default:                   return MapCreator::Create(id, in,objmap,objid);
    }
}

void* DlgCreator::Create (ClassId id) {
    if (id == DLGFCLASS_VIEW)   return new DlgFClassView;
    if (id == DLG_IDRAW_VIEW)   return new MapIdrawView;

    if (id == DLGFCLASS_SCRIPT) return new DlgFClassScript;
    if (id == DLGCOV_SCRIPT)    return new DlgCovScript;
    if (id == DLGLIB_SCRIPT)    return new DlgLibScript;
    if (id == DLGDB_SCRIPT)     return new DlgDbScript;
    if (id == DLG_IDRAW_SCRIPT) return new DlgIdrawScript;

    if (id == DLGFCLASS_PS)     return new OverlaysPS;
    if (id == DLG_IDRAW_PS)     return new OverlayIdrawPS;

    if (id == DLGFCLASS_RAW)    return new MapFClassRawScript;
    return MapCreator::Create(id);
}
